diff -urN ifmail-2.15dev5/ifgate/getmessage.c ifmail-2.15dev5.future/ifgate/getmessage.c
--- ifmail-2.15dev5/ifgate/getmessage.c	1999-03-31 17:14:32.000000000 +0300
+++ ifmail-2.15dev5.future/ifgate/getmessage.c	2004-06-22 13:54:30.000000000 +0300
@@ -62,6 +62,12 @@
 	off_t endmsg_off,tear_off,orig_off,via_off;
 	FILE *fp;
 
+#ifdef EDIT_FUTURE_DATES
+	time_t now=0L;
+	struct tm *ptm;
+	int now_year;
+	unsigned long date_fuzz=24L*60L*60L;
+#endif			
 	tmsg=&kmsg;
 
 	switch(tmp=iread(pkt))
@@ -353,6 +359,22 @@
 	if (hdr("Origin",kmsg) && orig_off==0L)
 		while (removehdr("Origin",&kmsg) == 0);
 
+#ifdef EDIT_FUTURE_DATES
+	time(&now);
+	if (newsmode && (mdate > now + date_fuzz)) {
+	    debug(5,"message date in the future \"%s\"",rfcdate(mdate));
+	    ptm = localtime(&now);
+	    now_year = ptm->tm_year;
+	    ptm = localtime(&mdate);
+	    ptm->tm_year = now_year;
+	    mdate=mktime(ptm);
+	    if (mdate > now + date_fuzz) {
+		ptm->tm_year = now_year - 1;
+		mdate=mktime(ptm);
+	    }
+	    debug(5,"new message date \"%s\"",rfcdate(mdate));
+	}
+#endif
 	endmsg_off=ftell(fp);
 	if ((tear_off) && (tear_off < endmsg_off)) endmsg_off=tear_off;
 	if ((orig_off) && (orig_off < endmsg_off)) endmsg_off=orig_off;
